import { BaseComponent } from '../../Utilities';
import { IButtonProps, IButton } from './Button.Props';
export declare class BaseButton extends BaseComponent<IButtonProps, {}> implements IButton {
    /**
     * _baseClassName can be overridden by subclasses to provide a unique class prefix to the class name used for
     * sub parts of the render template.
     */
    protected _baseClassName: string;
    /**
     * _variantClassName can be overridden by subclasses to add an extra default class name to the root element.
     */
    protected _variantClassName: string;
    private _buttonElement;
    private _labelId;
    private _descriptionId;
    private _ariaDescriptionId;
    constructor(props: IButtonProps, rootClassName: string, deprecationMap: any);
    render(): JSX.Element;
    focus(): void;
    protected onRenderContent(tag: any, buttonProps: any): JSX.Element;
    protected onRenderIcon(): JSX.Element;
    protected onRenderLabel(): JSX.Element;
    protected onRenderChildren(): {};
    protected onRenderDescription(): JSX.Element;
    protected onRenderAriaDescription(): JSX.Element;
}
