define([], function() { return "import * as React from 'react';\r\nimport {\r\n  css,\r\n  autobind\r\n} from '@uifabric/utilities';\r\nimport {\r\n  FocusZone,\r\n  FocusZoneDirection,\r\n  Button,\r\n  TextField,\r\n  List\r\n} from '../../../../index';\r\nimport './List.Scrolling.Example.scss';\r\n\r\nexport interface IListScrollingExampleProps {\r\n  items: any[];\r\n}\r\n\r\nexport interface IListScrollingExampleState {\r\n  selectedIndex: number;\r\n}\r\n\r\nconst evenItemHeight = 25;\r\nconst oddItemHeight = 50;\r\nconst numberOfItemsOnPage = 10;\r\n\r\nexport class ListScrollingExample extends React.Component<IListScrollingExampleProps, IListScrollingExampleState> {\r\n  private _list: List;\r\n\r\n  constructor(props) {\r\n    super(props);\r\n\r\n    this.state = {\r\n      selectedIndex: 0\r\n    };\r\n  }\r\n\r\n  public render() {\r\n    let { items } = this.props;\r\n\r\n    return (\r\n      <FocusZone direction={ FocusZoneDirection.vertical }>\r\n        <div>\r\n          <Button onClick={ () => this._scrollRelative(-10) }>-10</Button>\r\n          <Button onClick={ () => this._scrollRelative(-1) }>-1</Button>\r\n          <Button onClick={ () => this._scrollRelative(1) }>+1</Button>\r\n          <Button onClick={ () => this._scrollRelative(10) }>+10</Button>\r\n        </div>\r\n\r\n        <div>\r\n          Scroll item index:\r\n          <TextField value={ this.state.selectedIndex.toString(10) } onChanged={ (value) => {\r\n            this._scroll(parseInt(value, 10) || 0);\r\n          } } />\r\n        </div>\r\n\r\n        <div className='ms-ListScrollingExample-container' data-is-scrollable={ true }>\r\n          <List\r\n            ref={ this._resolveList }\r\n            items={ items }\r\n            getPageHeight={ (idx) => {\r\n              let h = 0;\r\n              for (let i = idx; i < idx + numberOfItemsOnPage; ++i) {\r\n                const isEvenRow = i % 2 === 0;\r\n\r\n                h += isEvenRow ? evenItemHeight : oddItemHeight;\r\n              }\r\n              return h;\r\n            } }\r\n            onRenderCell={ (item, index) => (\r\n              <div className='ms-ListScrollingExample-itemCell' data-is-focusable={ true }>\r\n                <div className={ css('ms-ListScrollingExample-itemContent', {\r\n                  'ms-ListScrollingExample-itemContent-even': index % 2 === 0,\r\n                  'ms-ListScrollingExample-itemContent-odd': index % 2 === 1\r\n                }) }>\r\n                  { index } &nbsp; { item.name }\r\n                </div>\r\n              </div>\r\n            ) }\r\n            />\r\n        </div>\r\n      </FocusZone>\r\n    );\r\n  }\r\n\r\n  private _scrollRelative(delta: number): void {\r\n    this._scroll(this.state.selectedIndex + delta);\r\n  }\r\n\r\n  private _scroll(index: number) {\r\n    const updatedSelectedIndex = Math.min(Math.max(index, 0), this.props.items.length - 1);\r\n\r\n    this.setState({\r\n      selectedIndex: updatedSelectedIndex\r\n    }, () => {\r\n      this._list.scrollToIndex(updatedSelectedIndex, (idx) => idx % 2 === 0 ? evenItemHeight : oddItemHeight);\r\n    });\r\n  }\r\n\r\n  @autobind\r\n  private _resolveList(list: List) {\r\n    this._list = list;\r\n  }\r\n}\r\n"; });