module.exports = "import * as React from 'react';\r\nimport { ChoiceGroup, IChoiceGroupOption } from '../../../../ChoiceGroup';\r\nimport { autobind } from '../../../../Utilities';\r\n\r\n/**\r\n * Interface for ChoiceGroupBasicExample state.\r\n */\r\nexport interface IChoiceGroupBasicExampleState {\r\n  imageKey: string;\r\n}\r\n\r\nexport class ChoiceGroupBasicExample extends React.Component<any, IChoiceGroupBasicExampleState> {\r\n  constructor() {\r\n    super();\r\n\r\n    this.state = {\r\n      imageKey: ''\r\n    };\r\n\r\n    this._onImageChoiceGroupChange = this._onImageChoiceGroupChange.bind(this);\r\n  }\r\n\r\n  public render() {\r\n    return (\r\n      <div>\r\n        <ChoiceGroup\r\n          options={ [\r\n            {\r\n              key: 'A',\r\n              text: 'Option A'\r\n            },\r\n            {\r\n              key: 'B',\r\n              text: 'Option B',\r\n              checked: true\r\n            },\r\n            {\r\n              key: 'C',\r\n              text: 'Option C',\r\n              disabled: true\r\n            },\r\n            {\r\n              key: 'D',\r\n              text: 'Option D',\r\n              checked: true,\r\n              disabled: true\r\n            }\r\n          ] }\r\n          onChange={ this._onChange }\r\n          label='Pick one'\r\n          required={ true }\r\n        />\r\n        <ChoiceGroup\r\n          label='Pick one image'\r\n          options={ [\r\n            {\r\n              key: 'bar',\r\n              checked: this.state.imageKey === 'bar',\r\n              imageSrc: 'dist/choicegroup-bar-unselected.png',\r\n              selectedImageSrc: 'dist/choicegroup-bar-selected.png',\r\n              imageSize: { width: 50, height: 50 },\r\n              text: 'Bar chart'\r\n            },\r\n            {\r\n              key: 'pie',\r\n              checked: this.state.imageKey === 'pie',\r\n              imageSrc: 'dist/choicegroup-pie-unselected.png',\r\n              selectedImageSrc: 'dist/choicegroup-pie-selected.png',\r\n              imageSize: { width: 50, height: 50 },\r\n              text: 'Pie chart'\r\n            }\r\n          ] }\r\n          onChange={ this._onImageChoiceGroupChange }\r\n        />\r\n      </div>\r\n    );\r\n  }\r\n\r\n  @autobind\r\n  private _onChange(ev: React.FormEvent<HTMLInputElement>, option: any) {\r\n    console.dir(option);\r\n  }\r\n\r\n  private _onImageChoiceGroupChange(ev: React.SyntheticEvent<HTMLElement>, option: IChoiceGroupOption) {\r\n    this.setState({\r\n      imageKey: option.key\r\n    });\r\n  }\r\n}\r\n";